function [res_classplsda] = classplsda(x,y,lv)


    // distributed under the CeCILL-C license
    // copyright INRA-IRSTEA 2013    

    // verication that there are only 2 groups for PLS-DA:
    if size(y,2)>2 then
        error('pls-da can only be processed with 2 groups')
    end
    
    // Initialisation:
    [n,q]=size(x);
    
    // from disjunctive to conjunctive:
    y=dis2conj(y);

    tscores=zeros(n,lv);
    Xx = x'*x;
    tol = norm(size(Xx),'inf')*norm(Xx)*%eps;   //default tolerance value
    tol = tol*10;                               //customized tolerance value
    s = pinv(Xx,tol);s=(s+s')/2;                //so S is perfectly symmetrical! 


    // PLS regression:
    res=ikpls(x,y,2,lv);
    
    // Outputs:
    res_classplsda.loadings=[];
    res_classplsda.loadings=res.loadings.d;
    res_classplsda.m_metric=[];
    res_classplsda.m_metric=s;
        

    
endfunction
