function [model] = cvreg(xi,yi,split,func,cent,varargin)


  // distributed under the CeCILL-C license
  // copyright INRA-IRSTEA 2013

  //-----------------------------------------------------------------
  // Adjustment of the input data to the Saisir format (if necessary) 
  //-----------------------------------------------------------------
  [x]=div(xi);
  [y]=div(yi);
  if x.i~= y.i then warning('labels in x and y do not match')
  end
  
  
  // --------------
  // Initialization
  // --------------      
  [n,p]=size(x.d);   
  x_mean=mean(x.d,1);
  y_mean=mean(y.d,1);    
  


  [rmsecv,ypredcv] = cvxx( x.d, y.d,split,func,cent,varargin(:));
  [rmsec,predU,bsU,bcoeffs,tscores,ploads,dof] = caltestxx(x.d,y.d,x.d,y.d,func,cent,varargin(:));
  
  
  // -------------------
  // degrees of freedom
  // -------------------
//  if func=='ridge' then lv2=max(size(lv));
//      else lv2=lv;
//  end
//  if centering2==1 then  rmsec=sqrt(rmsec^2*n./(ones(lv2,1)*(n-1)-[1:1:lv2]'));
//                   else  rmsec=sqrt(rmsec^2*n./(ones(lv2,1)*n-[1:1:lv2]'));
//  end;   
//  
  lv=size(rmsec,1);

  rmsec=sqrt(rmsec.^2 .* (n*ones(lv,1)) ./  ((n-cent)*ones(lv,1)-dof));  // JCB 23/08/13


  // ------
  // Output
  // ------

/////// à faire par la fonction calpls, calpcr, calmlr, etc.
  namelv=string([1:size(bcoeffs,2)]');
  namelv='LV'+namelv;
  
  model.err.d=[rmsec rmsecv];
  model.err.i=namelv;
  model.err.v=['rmsec';'rmsecv'];
   
  model.ypredcv.d=ypredcv;
  model.ypredcv.i=x.i;
  model.ypredcv.v=namelv;

 
  model.b.d=bcoeffs;
  model.b.i=x.v;
  model.b.v=namelv; 


 
  // pour gérer MLR et RIDGE
  if tscores~=[] then
    model.scores.d=tscores;
    model.scores.i='i'+string([1:1:size(x.i,1)]');    // modifié pour compatibilité avec curves
    model.scores.v=namelv;   
  end
  
  if ploads ~=[] then
    model.loadings.d=ploads;
    model.loadings.i=x.v;
    model.loadings.v=namelv;
  end
 
  model.x_mean.d=x_mean;
  model.x_mean.i='x_mean';
  model.x_mean.v=x.v;

  
  model.y_mean.d=y_mean;
  model.y_mean.i='y_mean';
  model.y_mean.v='y_mean';
  model.y_mean=div(model.y_mean);
  
  model.center=cent;

  model.err=div(model.err);
  model.err(5)=['number of latent variables';'RMSE'];
  
  model.ypredcv=div(model.ypredcv);
  model.ypredcv(5)=['observations';'y predicted'];

  model.b=div(model.b);
  model.b(5)=['initial variables';'b-regression coefficients'];
   
  model.x_mean=div(model.x_mean);
  model.x_mean(5)=['mean vector';'initial variables']
  model.x_mean=model.x_mean';
    
  if tscores~=[] then
    model.scores=div(model.scores);
    model.scores(5)=['observations';'scores of the observations onto the loadings ']
  end
  
  if ploads~=[] then  
    model.loadings=div(model.loadings);
    model.loadings(5)=['initial variables';'scores of the loadings '];
  end

  
  


endfunction


