function x2_saisir=div2csv(x_saisir,filename,id_decimal)
//saisir2excel 	  - Saves a saisir file in a format compatible with Excel
//function saisir2excel(X,filename)
//
//Input arguments
//===============
//X: SAISIR matrix to be saved
//filename: (string) name of the saved file
//
//Output argument
//===============
//none
//
//Transformq a saisir file into a simple .CSV file and save it on disk
//The separator is ";" 
//The extension '.csv' is added to the filename
//
////Typical example:
////===============
//saisir2excel(data,'mydata');
////Saves the SAISIR matrix "data", under the name "data.csv", with ";" as separator 
////This file is read by Excel

//  if id_decimal==',' then
//   saisir.d= strsubst(string(saisir.d),',','.');
//  elseif id_decimal=='.' then 
//   saisir.d= strsubst(string(saisir.d),'.',',');
//  end  
//  disp(saisir.d,'saisir.d=')
  
  saisir=div(x_saisir);
  
  separator = ';';
  
  // gestion du nom de fichier de sortie
  [n,p] = size(saisir.d);
  filename = convstr(filename,"u");
  if isempty(strindex(".csv",filename)) then
    filename = filename +".csv";
  end;
 
  // gestion de id_decimal
  if argn(2)==2 then
     id_decimal='.';
  end
  if  id_decimal~='.' & id_decimal~=',' then
    error('the decimal symbol should be '','' or ''.'' ') 

  else 
    fid = mopen(filename,"w");
    xformat1 = "%s"+separator;
    mfprintf(fid,xformat1,"  ");
    
    // gestion de saisir.v
    for col = 1:p-1
      mfprintf(fid,xformat1,stripblanks(saisir.v(col,eye())));
    end;
    mfprintf(fid,"%s \n",stripblanks(saisir.v(p,eye())));
  
    if id_decimal==','  then 
      xformat3 = "%s"+separator;
    elseif id_decimal=='.' then
      xformat3 = "%0.5g"+separator;
    end
  
    for row = 1:n
      mfprintf(fid,xformat1,saisir.i(row,eye()));

      // (p-1) premières colonnes; sans retour ligne
      for col=1:(p-1)
          if id_decimal==','  then
            mfprintf(fid,xformat3,strsubst(string(saisir.d(row,col)),'.',',')); 
          elseif id_decimal=='.'  then 
            mfprintf(fid,xformat3,saisir.d(row,col));  
          end
      end;
    
      // dernière colonne; avec retour ligne 
      if id_decimal==','  then
        mfprintf(fid,"%s \n",strsubst(string(saisir.d(row,p)),'.',','));
      elseif id_decimal=='.'  then
        mfprintf(fid,"%0.5g \n",saisir.d(row,p));
      end
    end
    
    mclose(fid);

  end

  
  // sortie div
  x2_saisir=div(saisir);  // ne sert que pour valider le script de test 



endfunction

 
